
--115200bps
--1bit = 8.68us
--10bit = 86.8us
--1ms = 11.52 bytes
--FA buffer = 15bytes ... few little
--取りこぼしの対処は後廻し...

maxrecv = 1470

sleep(10*1000)
if(fa.pio(0,0) == 0)then
	error()
end

require "/FTLE/breakpoint"
local recv_buf = ""

--シリアルを受信してバッファに詰め込む
function poll_recv()
    local cnt = 0
	while true do
		local c = fa.serial("read")
		--breakpoint() --中途停止用
     
		if(c ~= nil)then
			--有効なデータを受信したらバッファに高速に追加
			recv_buf = recv_buf .. string.format("%c",c)
            cnt = 0
        else
			break
            --受信データなしカウント
            --cnt = cnt + 1
            --if(recv_buf:len() > maxrecv)then
            --    break
            --end
        end

        --if(cnt > 40)then
        --    --受信中のデータが無くなったら抜ける
		--	break
		--end
	end
end

--[[
            --バッファの空き確保(255を超えたら頭を削って255に収める)
            if(recv_buf:len() > 255)then
                recv_buf = recv_buf:sub(2,-1)
                errmsg("overflow")
				collectgarbage() --メモリ不足防止
            end
]]


--PCの転送バッファの内容をシリアル出力する
function send_proc()
	--データ長を読み出す
	local len = tonumber(fa.sharedmemory("read", 0x200, 16, 0))
    if(len > 255)then
        len = 255
    end
    
	--データを読み出す
	local dat = fa.sharedmemory("read", 0x100, len, 0)
	--送信する
	fa.serial("write",dat)
	
	--送信完了
	fa.sharedmemory("write", 0x210, 1, "2")
end

--現在の受信データをPCの転送バッファに渡す
function trans_proc()
	local len = string.len(recv_buf)
    --データが無いなら更新しない
    if(len == 0)then
    	return
    end

	--長さを制限
	if(len > maxrecv)then
		len = maxrecv
		recv_buf = "[[overflow2]]" .. recv_buf
        errmsg("[[overflow2]]")
	end

	--データを転送バッファに書き込む
	fa.sharedmemory("write", 0x240, len, recv_buf)
	--データバッファを空にする(リセット)
	recv_buf=""
	--データの長さを文字列にして書き込む
	local lenS = string.format("%016d",len)
	fa.sharedmemory("write", 0x220, 16, lenS)
	
	--書き込み完了フラグを立てる
	fa.sharedmemory("write", 0x230, 1, "2")
end


--共有メモリの情報を取り出し処理する
function SharedMemoryCommunication()
	--PC → FA
	--PC側書き込み完了(1)で処理開始
	if(tonumber(fa.sharedmemory("read", 0x210, 1, 0)) == 1)then
		send_proc()
	end

	--FA → PC
	--PC側受信データ要求(1)で処理開始
	if(tonumber(fa.sharedmemory("read", 0x230, 1, 0)) == 1)then
		trans_proc()
	end
end

function errmsg(s)
	fa.sharedmemory("write", 0x500, 255, s)
end
------------------------

fa.serial("init")

--バッファのリセット(手抜き)
for i=0,2047 do
	fa.sharedmemory("write", i, 1, "0")
end

while true do
	collectgarbage() --メモリ不足防止
    sleep(0)
	breakpoint() --中途停止用

	--データを受信
	poll_recv()
	
	--共有メモリ処理(保護実行しておく)
	local sc,msg = pcall(SharedMemoryCommunication)
	if(sc ~= true)then
		--エラーメッセージがあればメモリに書き込んでおく(診断用)
		errmsg(msg)
	end
	
end


